using System;
using System.IO;
using System.Collections.Generic;

namespace Exercises_C_Sharp.E20_Lists
{
    class Exercise_5
    {
        public static void Start()
        {
            //Geben Sie die folgenden Informationen über die Zahlen in der Liste aus: Größte Zahl, kleinste Zahl, Durchschnitt (arithmetisches Mittel):
            List<int> intList = new List<int>() {14,2,12,32,51,31,53,12,34,34,2,45,45,23,62,72,25,40};

            
            /*Code START*/

            //Größte Zahl:
            int max = int.MinValue;
            foreach(var element in intList)
                if(max < element)
                    max = element;
            Console.WriteLine("Größte Zahl: " + max);
            //ODER:
            Console.WriteLine("Größte Zahl: " + intList.Max());

            
            //Größte Zahl:
            int min = int.MinValue;
            foreach(var element in intList)
                if(min > element)
                    min = element;
            Console.WriteLine("Größte Zahl: " + min);
            //ODER:
            Console.WriteLine("Größte Zahl: " + intList.Min());

            //Durchschnitt:
            int sum = 0;
            int count = 0;
            foreach(var element in intList)
            {
                sum += element;
                count++;
            }
            double av = (double)sum / count;
            Console.WriteLine("Der Durchschnitt: " + av);

            //ODER:
            Console.WriteLine("Der Durchschnitt: " + intList.Average());
            

            /*Code ENDE*/
        }
    }
}